import java.util.ArrayList;
import java.util.Random;

public class AchievementPage {
	private static int nextID = 1;
	private final int id;
	public final yq stackIcon;
	public final String title;
	protected ArrayList<Integer> list = new ArrayList<Integer>();

	public AchievementPage() {
		id = 0;
		stackIcon = new yq(oe.m[2]);
		title = "Minecraft";
		SAPI.Achievements.addPage(this);
	}

	public AchievementPage(yq stackIcon, String title) {
		id = nextID++;
		this.stackIcon = stackIcon;
		this.title = title;
		SAPI.Achievements.addPage(this);
	}

	public boolean equals(Object other) {
		if (other == null) return false;
		if (!(other instanceof AchievementPage)) return false;
		AchievementPage page = (AchievementPage)other;
		return id == page.id;
	}

	public final int getID() {
		return id;
	}

	public void addAchievements(aca... achievements) {
		for (aca a : achievements) list.add(a.a);
	}

	public int bgGetSprite(Random random, int i, int j) {
		int l = random.nextInt(1 + j) + j / 2;

		oe b = oe.m[12];
		if (l > 37 || j == 35) b = oe.m[7];
		else if (l == 22) b = random.nextInt(2) != 0 ? oe.m[73] : oe.m[56];
		else if (l == 10) b = oe.m[15];
		else if (l == 8) b = oe.m[16];
		else if (l > 4) b = oe.m[1];
		else if (l > 0) b = oe.m[3];
		return b.bN;
	}
}