import java.io.File;
import java.lang.reflect.Method;
import java.util.HashMap;
import net.minecraft.client.Minecraft;

public class DimensionBase {
	public static HashMap<Integer,Class<? extends aip>> providerMap = new HashMap<Integer, Class<? extends aip>>(5,.75f);
	public static HashMap<Integer,DimensionBase> dimMap = new HashMap<Integer,DimensionBase>(5,.75f);
	public Class<? extends aip> worldProvider;
	public Class<? extends oa> teleporter;
	public String name;
	public int number;
	public File DimensionDIR;
	public String soundTrigger;
	public String soundTravel;
	public static vq normalWorld;

	public static aip getWorldProvider(int var0) {
		if (providerMap.containsKey(var0)) {
			Class<? extends aip> var1 = providerMap.get(var0);
			try {
				return var1.newInstance();
			} catch (Exception var3) {}
		}
		if (var0 == -1) return new ahv();
		if (var0 == 2) return new hv();

		return new ma();
	}

	public oa getTeleporter() {
		try {
			if (teleporter != null) return teleporter.newInstance();
		} catch (Exception var2) {}
		return null;
	}

	public File GetDimensionSaveDir() {
		this.DimensionDIR = new File(GetSaveDir(), this.name);
		return this.DimensionDIR;
	}

	void usePortal() {
		System.out.print("use portal");
		this.DimensionDIR = this.GetDimensionSaveDir();
		Minecraft var1 = ModLoader.getMinecraftInstance();
		var1.f.b(var1.h);
		var1.h.G = false;
		vq var2 = null;
		boolean var3 = false;
		var1.h.aB = var1.h.aB != this.number ? this.number : 0;
		if (var1.h.aB == this.number) var3 = true;

		var1.h.c(var1.h.o,var1.h.p,var1.h.q,var1.h.u,var1.h.v);
		var1.f.a(var1.h,false);
		var2 = new vq(var1.f,getWorldProvider(var1.h.aB));
		this.WorldConstructor(var2);
		if (var1.h.aB != 0 && var1.h.aB != -1) {
			this.changeWorld(var2, ChangeMessage(!var3, this.name),var1.h);
		} else {
			var1.a(var2, ChangeMessage(!var3, this.name),var1.h);
		}

		var1.h.k = var1.f;
		var1.f.a(var1.h, false);
		oa var4 = this.getTeleporter();
		if (var4 == null) var4 = new oa();

		var4.a(var1.f,var1.h);
	}

	public static void usePortal(int var0) {
		System.out.println(var0);
		DimensionBase var1 = (DimensionBase) dimMap.get(Integer.valueOf(var0));
		if (var1 == null) System.out.println("Why");

		var1.usePortal();
	}

	private static String ChangeMessage(boolean var0, String var1) {
		return var0 ? "Leaving the " + var1 : "Entering the " + var1;
	}

	public static void respawn(boolean var0, int var1) {
		Minecraft var2 = ModLoader.getMinecraftInstance();
		if (!var2.f.I && !var2.f.y.d()) usePortal(var1);
		var2.a(var0, var1, false);

		try {
			Method var3 = Minecraft.class.getDeclaredMethod("d", new Class[] { String.class });
			var3.setAccessible(true);
			var3.invoke(var2, new Object[] { "Respawning" });
		} catch (Exception var4) {var4.printStackTrace();}

		if (var2.s instanceof tr) var2.a((tr)null);
	}

	public void changeWorld(vq var1, String var2, xb var3) {
		Minecraft var4 = ModLoader.getMinecraftInstance();
		act var5 = new act(this.DimensionDIR);
		var1.A = new jx(var1, var5, var1.y.b());
		var4.a(var1, var2, var3);
	}

	static File GetSaveDir() {
		Minecraft var0 = ModLoader.getMinecraftInstance();
		if (var0.f != null) {
			eb var1 = (eb)var0.f.B;
			System.out.println(var1.a());
			return var1.a();
		} else return null;
	}

	static File GetSaveDir(aif var0) {
		System.out.println(((eb)var0).a());
		return ((eb)var0).a();
	}

	public DimensionBase(int var1, Class<? extends aip> var2, Class<? extends oa> var3) {
		this.number = var1;
		this.worldProvider = var2;
		this.teleporter = var3;
		providerMap.put(Integer.valueOf(this.number), var2);
		dimMap.put(Integer.valueOf(var1), this);
	}

	public File GetDimensionSaveDir(aif var1) {
		this.DimensionDIR = new File(GetSaveDir(var1), this.name);
		return this.DimensionDIR;
	}

	public void WorldConstructor(vq var1) {}
}

/*
import java.io.File;
import java.lang.reflect.Method;
import java.util.HashMap;
import net.minecraft.client.Minecraft;

public class DimensionBase {
	public static HashMap<Integer,Class<? extends aip>> providerMap = new HashMap<Integer,Class<? extends aip>>(5,.75f);
	public static HashMap<Integer,DimensionBase> dimMap = new HashMap<Integer,DimensionBase>(5,.75f);
	public Class<? extends aip> worldProvider;
	public Class<? extends oa> teleporter;
	public String name;
	public int number;
	public File DimensionDIR;
	public String soundTrigger;
	public String soundTravel;
	public static ry normalWorld;

	public static aip getWorldProvider(int i) {
		if (providerMap.containsKey(Integer.valueOf(i))) {
			Class<? extends aip> class1 = providerMap.get(Integer.valueOf(i));
			try {
				return (aip)class1.newInstance();
			} catch (InstantiationException instantiationexception) {} catch (IllegalAccessException illegalaccessexception) {}
		} else if (i == -1) return new ahv();
		else if (i == 2) return new hv();
		return new ma();
	}

	public oa getTeleporter() {
		try {
			if (teleporter != null) { return (oa)teleporter.newInstance(); }
		} catch (InstantiationException instantiationexception) {} catch (IllegalAccessException illegalaccessexception) {}
		return null;
	}

	public File GetDimensionSaveDir() {
		DimensionDIR = new File(GetSaveDir(),name);
		return DimensionDIR;
	}

	void usePortal() {
		System.out.print("use portal");
		DimensionDIR = GetDimensionSaveDir();
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		minecraft.f.b(minecraft.h);
		minecraft.h.G = false;
		vq world = null;
		boolean flag = false;
		minecraft.h.bK = minecraft.h.bK != number ? number : 0;
		if (minecraft.h.bK == number) flag = true;
		minecraft.h.c(minecraft.h.o,minecraft.h.p,minecraft.h.q,minecraft.h.u,minecraft.h.v);
		minecraft.f.a(minecraft.h,false);
		world = new vq(minecraft.f,getWorldProvider(minecraft.h.aB));
		WorldConstructor(world);
		if (minecraft.h.bK == 0 || minecraft.h.bK == -1) {
			minecraft.a(world,ChangeMessage(!flag,name),minecraft.h);
		} else {
			changeWorld(world,ChangeMessage(!flag,name),minecraft.h);
		}
		minecraft.h.k = minecraft.f;
		minecraft.f.a(minecraft.h,false);
		oa teleporter1 = getTeleporter();
		if (teleporter1 == null) teleporter1 = new oa();
		teleporter1.a(minecraft.f,minecraft.h);
	}

	public static void usePortal(int i) {
		System.out.println(i);
		DimensionBase dimensionbase = (DimensionBase)dimMap.get(Integer.valueOf(i));
		if (dimensionbase == null) {
			System.out.println("Why");
		}
		dimensionbase.usePortal();
	}

	private static String ChangeMessage(boolean flag, String s) {
		return flag ? (new StringBuilder("Leaving the ")).append(s).toString() : (new StringBuilder("Entering the ")).append(s).toString();
	}

	public static void respawn(boolean flag, int i) {
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		if (!minecraft.f.I && !minecraft.f.y.d()) {
			usePortal(i);
		}
		minecraft.a(flag,i,false);
		try {
			Method method = (net.minecraft.client.Minecraft.class).getDeclaredMethod("d",new Class[]{java.lang.String.class});
			method.setAccessible(true);
			method.invoke(minecraft,new Object[]{"Respawning"});
		} catch (Exception exception) {
			exception.printStackTrace();
		}
		if (minecraft.s instanceof j) minecraft.a((xe)null);
	}

	public void changeWorld(vq world, String s, xb entityplayer) {
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		act threadedchunkloader = new act(DimensionDIR);
		world.A = new jz(world,threadedchunkloader,world.y.c());
		minecraft.a(world,s,entityplayer);
	}

	static File GetSaveDir() {
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		if (minecraft.f != null) {
			eb savehandler = (eb)minecraft.f.B;
			System.out.println(savehandler.a());
			return savehandler.a();
		} else {
			return null;
		}
	}

	static File GetSaveDir(aif saveHandler) {
		System.out.println(((eb)saveHandler).a());
		return ((eb)saveHandler).a();
	}

	public DimensionBase(int i, Class<? extends aip> worldProvider, Class<? extends oa> teleporter) {
		number = i;
		this.worldProvider = worldProvider;
		this.teleporter = teleporter;
		providerMap.put(number,worldProvider);
		dimMap.put(i,this);
	}

	public File GetDimensionSaveDir(aif saveHandler) {
		DimensionDIR = new File(GetSaveDir(saveHandler),name);
		return DimensionDIR;
	}
	
	public void WorldConstructor(vq world) {
		// TODO Auto-generated method stub
	}
}
 */